#include<stdio.h>
#include<math.h>
#include<stdlib.h>

#define VERBOSE   0     /* вϤʤʤ 0 ˤ */
#define EPS       1E-3  /* Ƹ */
#define MAX_ITER 1000   /* 緫֤ */

#define nx 7
#define ny 5
#define nz 5
#define nxz 35 
#define nxyz 175 

void init(void);
void mesh(double xx[],double yy[],double zz[]);
void prefem(void);
void mat(double xx[],double yy[],double zz[],
	 double a[][nxyz],double phi[]);
void elbcon(double a[][nxyz],double phi[]);
int gseidel(int n, double a[][nxyz], double x[], double phi[]);
void calcur(double xx[],double yy[],double zz[],
double x[],double jx[nx][ny][nz],double jy[nx][ny][nz],double jz[nx][ny][nz]);
void output(double xx[],double yy[],double zz[],
double jx[nx][ny][nz],double jy[nx][ny][nz],double jz[nx][ny][nz]);

#define nnx nx-1
#define nny ny-1
#define nnz nz-1
#define ndx nx-1wa[i]=ww[l][j][k]
#define ndy ny-1
#define ndz nz-1b
#define dphix 156.0
#define vele 0.0

#define nf 576
#define mx nx+4
#define my ny+4
#define mz nz+4

#define miend 2
#define meend 4
#define mnum nxyz


/*Global variables*/
double u[nxyz],v[nxyz],bfield[nxyz],xa[nxyz],ya[nxyz],za[nxyz],bfielda[nxyz];
int np[576][4];
double sig[nxyz],bet[nxyz];
double a[nxyz][nxyz],phi[nxyz];
double ex[nxyz],ey[nxyz],ez[nxyz];
double uu[nx][ny][nz],vv[nx][ny][nz];
double ua[nxyz],va[nxyz],siga[nxyz],beta[nxyz],bav[nxyz];
double b[nx],ex[nxyz],ey[nxyz],ez[nxyz];
double  sig[nxyz],bet[nxyz];
/*
double  jx[nx][ny][nz],jy[nx][ny][nz],jz[nx][ny][nz];
*/
int main(void)
{
	int n;
	double xx[nx],yy[ny],zz[nz];
	double a[nxyz][nxyz],phi[nxyz],x[nxyz];
	double jx[nx][ny][nz],jy[nx][ny][nz],jz[nx][ny][nz];

	n=nxyz;
	printf("Program start.\n");
	init();
	mesh(xx,yy,zz);
	prefem();
	mat(xx,yy,zz,a,phi);
	elbcon(a,phi);
	gseidel(n,a,x,phi);
	calcur(xx,yy,zz,x,jx,jy,jz);
	output(xx,yy,zz,jx,jy,jz);
	printf("Program finished.\n");

	return 0;
}

void init(void)
{
	int i,j,k,n;
  FILE *fp,*gp,*hp,*ip;

  fp=fopen("u.dat","r");
  gp=fopen("v.dat","r");
  hp=fopen("sig.dat","r");
  ip=fopen("bet.dat","r");

n=0;
	for(i=0;i<nx;i++){
		for(j=0;j<ny;j++){
			for(k=0;k<nz;k++){
	fscanf(fp,"%lf",&uu[i][j][k]);
	fscanf(gp,"%lf",&vv[i][j][k]);
	fscanf(hp,"%lf",&sig[n]);
	fscanf(ip,"%lf",&bet[n]);
	n++;
			}
		}
	}
	
	fclose(fp);
	fclose(gp);
	fclose(hp);
	fclose(ip);
	
	
	for(i=0;i<nxyz;i++) bfield[i]=10.0;

}

void mesh(double xx[],double yy[],double zz[])
{
	
	int i;
	double xstart,entrle,exitle,xle,elecle;
	double clo,yl,zlen,dx;

      xstart=1.70;
      entrle=3.0/10000.0;
      exitle=3.6/1000.0;
      elecle=2.01/100.0;
      xle=entrle+exitle+elecle;
      clo=xle/nx;
      dx=xle/(nx-1);
      for(i=0;i<nx;i++) xx[i]=xstart+dx*i;

      yl=1.0/100.0;
	  for(i=0;i<ny;i++) yy[i]=yl*i/(ny-1);
	  
      zlen=0.1/10.0;
      for( i=0;i<nz;i++)
        zz[i]=zlen*i/(nz-1);


}


void prefem(void)
{
int l,m,n;
int nn;/*,nxxz;*/
int n1,n2,n3,n4,n5,n6,n7,n8;

      nn=0;
	  /*    nxxz=nx*nz;*/
      for( m=1;m<=nny;m++){
      for( n=1;n<=nnz;n++){
      for( l=1;l<=nnx;l++){
        n1=l+(m-1)*nxz+(n-1)*nx;
        n3=n1+nx;
        n5=n1+nxz;
        n2=n1+1;
        n4=n3+1;
        n6=n5+1;
        n7=n5+nx;
		n8=n7+1;
 
		/* 1 element */
        np[nn][0]=n1;
        np[nn][1]=n2;
        np[nn][2]=n3;
        np[nn][3]=n5;
		/* 2 element */
        nn=nn+1;
        np[nn][0]=n3;
        np[nn][1]=n2;
        np[nn][2]=n7;
        np[nn][3]=n5;
		/* 3 element */
        nn=nn+1;
        np[nn][0]=n5;
        np[nn][1]=n2;
        np[nn][2]=n7;
        np[nn][3]=n6;
		/* 4 element */
        nn=nn+1;
        np[nn][0]=n2;
        np[nn][1]=n4;
        np[nn][2]=n3;
        np[nn][3]=n7;
		/* 5 element */
        nn=nn+1;
        np[nn][0]=n4;
        np[nn][1]=n7;
        np[nn][2]=n2;
        np[nn][3]=n6;
		/* 6 element */
        nn=nn+1;
        np[nn][0]=n4;
        np[nn][1]=n7;
        np[nn][2]=n6;
        np[nn][3]=n8;
		nn=nn+1;
   }
}
}
	  /*
printf("nf=%d\n",nf);

fp=fopen("np.dat","w");
	 for(i=0;i<nf;i++)
		  for(j=0;j<4;j++){
		  fprintf(fp,"%d %d %d\n",i,j,np[i][j]);
		  }
		  fclose(fp);
*/

}

void mat(double xx[],double yy[],double zz[],double a[][nxyz], double phi[])

{

int i,j,k,l,p,q,m,n;
 double ub[4],vb[4],sigb[4],betb[4],bfieldb[4],xb[4],yb[4],zb[4];
 double uav,vav,sigav,betav,bfieldav;
 double volume,ai[4],bi[4],ci[4],di[4];
 double kappa,A[4][4],bbb[4];

 for (j=0;j<nxyz;j++){      /*ȥ٥ȥν*/
   for (k=0;k<nxyz;k++){
     
     a[j][k]=0;
   }
   phi[j]=0;
 }

 i=0;                           /*켡*/
for( j=0; j<ny; j++ ){
  for( k=0; k<nz; k++ ){
    for( l=0; l<nx; l++ ){ 

      ua[i]=uu[l][j][k];

      va[i]=vv[l][j][k];

      xa[i]=xx[l];

      ya[i]=yy[j];

      za[i]=zz[k];

      bfielda[i]=bfield[l];

      i=i+1;
   }
  }
 }


 for(p=0;p<nf;p++) {            
  for(q=0;q<4;q++){              /*Ǥγκɸ*/
   

    m=np[p][q]-1;      
    xb[q]=xa[m];
    yb[q]=ya[m];
    zb[q]=za[m];
    ub[q]=ua[m];
    vb[q]=va[m];

    
   
    sigb[q]=sig[m];
    betb[q]=bet[m];
    bfieldb[q]=bfield[m];
  }

  uav=(ub[1]+ub[2]+ub[3]+ub[4])/4.0;                /*ʿͤ*/
  vav=(vb[1]+vb[2]+vb[3]+vb[4])/4.0;
  sigav=(sigb[1]+sigb[2]+sigb[3]+sigb[4])/4.0;
  betav=(betb[1]+betb[2]+betb[3]+betb[4])/4.0;
  bfieldav=(bfieldb[1]+bfieldb[2]+bfieldb[3]+bfieldb[4])/4.0;

 

                                                     /*Ѻɸ*/      
  volume=(xb[0]*yb[1]*zb[3]+xb[2]*yb[0]*zb[3]+xb[1]*yb[2]*zb[3]
        +xb[0]*yb[3]*zb[2]+xb[2]*yb[3]*zb[1]+xb[1]*yb[3]*zb[0]
        +xb[3]*yb[1]*zb[2]+xb[3]*yb[0]*zb[1]+xb[3]*yb[2]*zb[0]
        +xb[2]*yb[1]*zb[0]+xb[1]*yb[0]*zb[2]+xb[0]*yb[2]*zb[1]
        -xb[0]*yb[1]*zb[2]-xb[2]*yb[0]*zb[1]-xb[1]*yb[2]*zb[0]
        -xb[2]*yb[1]*zb[3]-xb[1]*yb[0]*zb[3]-xb[0]*yb[2]*zb[3]
        -xb[2]*yb[3]*zb[0]-xb[1]*yb[3]*zb[2]-xb[0]*yb[3]*zb[1]
        -xb[3]*yb[1]*zb[0]-xb[3]*yb[0]*zb[2]-xb[3]*yb[2]*zb[1])/6;

  


  for(i=0;i<4;i++){
    
    if(i==0){
      j=1,k=2,l=3;
    
      ai[i]=(xb[j]*yb[k]*zb[l]+xb[k]*yb[l]*zb[j]+xb[l]*yb[j]*zb[k]
	  -xb[j]*yb[l]*zb[k]-xb[k]*yb[j]*zb[l]-xb[l]*yb[k]*zb[j])/(6*volume);
    
      bi[i]=(yb[k]*zb[l]+yb[l]*zb[j]+yb[j]*zb[k]
	  -yb[l]*zb[k]-yb[j]*zb[l]-yb[k]*zb[j])/((-6)*volume); 
     
      ci[i]=(xb[j]*zb[l]+xb[k]*zb[j]+xb[l]*zb[k]
	  -xb[j]*zb[k]-xb[k]*zb[l]-xb[l]*zb[j])/((-6)*volume);
     
      di[i]=(xb[j]*yb[k]+xb[k]*yb[l]+xb[l]*yb[j]
	  -xb[j]*yb[l]-xb[k]*yb[j]-xb[l]*yb[k])/((-6)*volume);
   
}

    if(i==1){
      j=2,k=3,l=0;
    
      ai[i]=(xb[j]*yb[k]*zb[l]+xb[k]*yb[l]*zb[j]+xb[l]*yb[j]*zb[k]
	  -xb[j]*yb[l]*zb[k]-xb[k]*yb[j]*zb[l]-xb[l]*yb[k]*zb[j])/(6*volume);
    
      bi[i]=(yb[k]*zb[l]+yb[l]*zb[j]+yb[j]*zb[k]
	  -yb[l]*zb[k]-yb[j]*zb[l]-yb[k]*zb[j])/((-6)*volume); 
     
      ci[i]=(xb[j]*zb[l]+xb[k]*zb[j]+xb[l]*zb[k]
	  -xb[j]*zb[k]-xb[k]*zb[l]-xb[l]*zb[j])/((-6)*volume);
     
      di[i]=(xb[j]*yb[k]+xb[k]*yb[l]+xb[l]*yb[j]
	  -xb[j]*yb[l]-xb[k]*yb[j]-xb[l]*yb[k])/((-6)*volume);
         
         
}

    if(i==2){
      j=3,k=0,l=1;
    
      ai[i]=(xb[j]*yb[k]*zb[l]+xb[k]*yb[l]*zb[j]+xb[l]*yb[j]*zb[k]
	  -xb[j]*yb[l]*zb[k]-xb[k]*yb[j]*zb[l]-xb[l]*yb[k]*zb[j])/(6*volume);
    
      bi[i]=(yb[k]*zb[l]+yb[l]*zb[j]+yb[j]*zb[k]
	  -yb[l]*zb[k]-yb[j]*zb[l]-yb[k]*zb[j])/((-6)*volume); 
     
      ci[i]=(xb[j]*zb[l]+xb[k]*zb[j]+xb[l]*zb[k]
	  -xb[j]*zb[k]-xb[k]*zb[l]-xb[l]*zb[j])/((-6)*volume);
     
      di[i]=(xb[j]*yb[k]+xb[k]*yb[l]+xb[l]*yb[j]
	  -xb[j]*yb[l]-xb[k]*yb[j]-xb[l]*yb[k])/((-6)*volume);


}
    if(i==3){
      j=0,k=1,l=2;
    
      ai[i]=(xb[j]*yb[k]*zb[l]+xb[k]*yb[l]*zb[j]+xb[l]*yb[j]*zb[k]
	  -xb[j]*yb[l]*zb[k]-xb[k]*yb[j]*zb[l]-xb[l]*yb[k]*zb[j])/(6*volume);
    
      bi[i]=(yb[k]*zb[l]+yb[l]*zb[j]+yb[j]*zb[k]
	  -yb[l]*zb[k]-yb[j]*zb[l]-yb[k]*zb[j])/((-6)*volume); 
     
      ci[i]=(xb[j]*zb[l]+xb[k]*zb[j]+xb[l]*zb[k]
	  -xb[j]*zb[k]-xb[k]*zb[l]-xb[l]*zb[j])/((-6)*volume);
     
      di[i]=(xb[j]*yb[k]+xb[k]*yb[l]+xb[l]*yb[j]
	  -xb[j]*yb[l]-xb[k]*yb[j]-xb[l]*yb[k])/((-6)*volume);

	  }
    //   printf("%g, %g, %g, %g\n",ai[i],bi[i],ci[i],di[i]);
  }

  kappa=sigav/(1+betav*betav);            /*Ĥ*/
    for(m=0;m<4;m++){
      for(n=0;n<4;n++){
	A[n][m]=-kappa*(bi[n]*bi[m]+ci[n]*ci[m])+kappa*betav*(bi[n]*ci[m]-ci[n]*bi[m])-sigav*di[n]*di[m];      
      }
}





    for(n=0;n<4;n++){                     /*bĤ*/         
      bbb[n]=-kappa*(bi[n]*(betav*uav*bfieldav+vav*bfieldav)+ci[n]*(-uav*bfieldav+betav*vav*bfieldav));


}

                                            /*γĥ*/
    for(n=0;n<4;n++){
      for(m=0;m<4;m++){
	a[np[p][n]-1][np[p][m]-1]=a[np[p][n]-1][np[p][m]-1]+A[n][m];
}
}

    /*٥ȥγĥ*/
    for(n=0;n<4;n++){
      phi[np[p][n]-1]=phi[np[p][n]-1]+bbb[n];
    }
    /*
    for(i=0;i<nxyz;i++){
      for(j=0;j<nxyz;j++){
	printf(" %g",a[i][j]);
      }
      printf("\n");
    }
    */





}


    for (i=0;i<nxyz;i++) printf("%d,  %g \n",i,phi[i]);
}


void elbcon(double a[][nxyz],double phi[])
{
int i,m,n;
int nent,next,nfwd,nbwd,ngrid;
/* x */
      for(n=1;n<=nz;n++)
      for(m=1;m<=ny;m++){
        nent=nxz*(n-1)+nx*(m-1);
        next=nxz*(n-1)+nx*m-1;
        for(i=0;i<nxyz;i++){
          a[i][nent]=0.0;
          a[i][next]=0.0;
          a[nent][i]=0.0;
          a[next][i]=0.0;
  }
  
        a[nent][nent]=-1.0;
/*        a[ipr(nx-2)][nent]=1.0;
        a[ipr(-nx+2)][next]=-1.0;*/
        a[next][next]=1.0;
        phi[nent]=dphix;
        phi[next]=dphix;
}
   
/* z */
		for(m=0;m<nx-2;m++)
		for(n=1;n<=ny-2;n++){
		nfwd=nxz+2+(n-1)*nxz+m-1;
		nbwd=nxz+nx*(nz-1)+2+(n-1)*nxz+m-1;
        for(i=0;i<nxyz;i++){
          a[i][nfwd]=0.0;
          a[i][nbwd]=0.0;
          a[nfwd][i]=0.0;
          a[nbwd][i]=0.0;
   }
        a[nfwd][nfwd]=-1.0;
 /*       a(ipr(nx*(nz-2)),nfwd)=1.0d0
        a(ipr(-nx*(nz-2)),nbwd)=-1.0d0 */
        a[nbwd][nbwd]=1.0;
        phi[nfwd]=0.0;
        phi[nbwd]=0.0;
        }
        
/* Ŷ */
		for(m=0;m<nx-4;m++)
		for(n=1;n<=nz;n++){
		ngrid=2+(n-1)*nx+m-1;
        for(i=0;i<nxyz;i++){
          a[i][ngrid]=0.0;
          a[ngrid][i]=0.0;
   }
        a[ngrid][ngrid]=1.0;
        phi[ngrid]=vele;
     
}

}


int gseidel(int n, double a[][nxyz], double x[], double phi[])
{
	int j, i, ok, iter;
	double s;

		for(i=0;i<nxyz;i++) x[i]=0.00001;
	for (iter = 1; iter <= MAX_ITER; iter++) {
		ok = 1;
		for (i = 0; i < n; i++) {
			s = phi[i];
			for (j = 0    ; j < i; j++) s -= a[i][j] * x[j];
			for (j = i + 1; j < n; j++) s -= a[i][j] * x[j];
			s /= a[i][i];  /* 餫гʬ1ˤƤ */
			if (ok && fabs(x[i] - s) > EPS * (1 + fabs(s)))
				ok = 0;
			x[i] = s;  /* SORˡʤ㤨 x[i] += 1.2 * (s - x[i]); */
		}
/*		#if VERBOSE
		/*	printf("%3d:\n", iter); */
		/*	vecprint(x, n, 7, "%11.6f"); */
/*		#endif */		
		printf("iter=%d\n",iter);
		if (ok) return EXIT_SUCCESS;  /*  */
	}
	printf("«\n");
	return EXIT_FAILURE;  /* « */
}

void calcur(double xx[],double yy[],double zz[],double x[],
			double jx[nx][ny][nz],double jy[nx][ny][nz],double jz[nx][ny][nz])
{

      int i,j,k,l,m,n,nc2;
	  double totj,dy1,dy2,dxx,dzz,ak,dy,dz;
	  int no1,no2;
/*	  double ttj,tj; */
	  int ment,mext,mpen,mpex,mf,mb,mfp,mbp;
	  double ajx[nxyz],ajy[nxyz],ajz[nxyz],ajh[nxyz];
	  FILE *fp;


		  fp=fopen("x.dat","w");
    	  for(i=0;i<nxyz;i++)
		  fprintf(fp,"%d %lf\n",i,x[i]);
		  fclose(fp);

      totj=0.0;
      nc2=(ny-1)*nxz-nx;
      dy1=yy[1]-yy[0];
      dy2=yy[ny-1]-yy[ny-2];
      
      for(l=2;l<=nx-1;l++){
        dxx=xx[l+1-1]-xx[l-1-1];
	for(n=1;n<=nz;n++){
          no1=(n-1)*nx+l;
          no2=n*nx+l+nc2;
          ex[no1-1]=(x[no1-1-1]-x[no1+1-1])/dxx;
          ex[no2-1]=(x[no2-1-1]-x[no2+1-1])/dxx;
   }
}

      
	for(n=2;n<=nz-1;n++){
	  for(l=2;l<=nx-1;l++){
          no1=(n-1)*nx+l;
          no2=l+n*nx+nc2;
          ey[no1-1]=(x[no1-1]-x[no1+nxz-1])/dy1;
          ey[no2-1]=(x[no2-nxz-1]-x[no2-1])/dy2;
  
}
}

      
	for(n=2;n<=nz-1;n++){
        dzz=zz[n+1]-zz[n-1];
       
	  for(l=2;l<=nx-1;l++){
          no1=(n-1)*nx+l;
          no2=n*nx+l+nc2;
          ez[no1-1]=(x[no1-nx-1]-x[no1+nx-1])/dzz;
          ez[no2-1]=(x[no2-nx-1]-x[no2+nx-1])/dzz;
  }
 }

      
	for(m=2;m<=ny-1;m++){
        dy=yy[m+1-1]-yy[m-1-1];
	  for(n=2;n<=nz-1;n++){
          dz=zz[n+1-1]-zz[n-1-1];
            for(l=1;l<nx-1;l++){
            i=l+(n-1)*nx+(m-1)*nxz;
            ex[i-1]=(x[i-1-1]-x[i+1-1])/(xx[l+1-1]-xx[l-1-1]);
            ey[i-1]=(x[i-nxz-1]-x[i+nxz-1])/dy;
            ez[i-1]=(x[i-nx-1]-x[i+nx-1])/dz;
}
}
}

	for(k=2;k<=nz-1;k++){
		for(j=1;j<=ny;j++){
        ment=1+(j-1)*nxz+(k-1)*nx;
        mext=nx+(j-1)*nxz+(k-1)*nx;
        mpen=ment+nx-2;
        mpex=mext-nx+2;
        ex[ment-1]=ex[mpen-1];
        ex[mext-1]=ex[mpex-1];
        ey[ment-1]=ey[mpen-1];
        ey[mext-1]=ey[mpex-1];
        ez[ment-1]=ez[mpen-1];
        ez[mext-1]=ez[mpex-1];
   }
}

	for(j=1;j<=ny;j++){
		for(i=1;i<=nx;i++){
        mf=i+(j-1)*nxz;
        mb=i+(j-1)*nxz+(nz-1)*nx;
        mfp=mf+(nz-2)*nx;
        mbp=mb-(nz-2)*nx;
        ex[mf-1]=ex[mfp-1];
        ex[mb-1]=ex[mbp-1];
        ey[mf-1]=ey[mfp-1];
        ey[mb-1]=ey[mbp-1];
        ez[mf-1]=ez[mfp-1];
        ez[mb-1]=ez[mbp-1];
}
}
 
     for(i=1;i<=nxyz;i++){
 ak=sig[i-1]/(1.0+bet[i-1]*bet[i-1]);
 ajx[i-1]=ak*(ex[i-1]-bet[i-1]*ey[i-1]+(bet[i-1]*ua[i-1]+va[i-1])*bfield[i-1]);
 ajy[i-1]=ak*(bet[i-1]*ex[i-1]+ey[i-1]-(ua[i-1]-bet[i-1]*va[i-1])*bfield[i-1]);
 ajz[i-1]=sig[i-1]*ez[i-1];
  }
 
	for(k=2;k<=nz-1;k++){
	  for(j=1;j<=ny;j++){
        ment=1+(j-1)*nxz+(k-1)*nx;
        mext=nx+(j-1)*nxz+(k-1)*nx;
        mpen=ment+nx-2;
        mpex=mext-nx+2;
        ajx[ment-1]=ajx[mpen-1];
        ajx[mext-1]=ajx[mpex-1];
        ajy[ment-1]=ajy[mpen-1];
        ajy[mext-1]=ajy[mpex-1];
        ajz[ment-1]=ajz[mpen-1];
        ajz[mext-1]=ajz[mpex-1];
  }
}

	for(j=1;j<=ny;j++){
		for(i=1;i<=nx;i++){
        mf=i+(j-1)*nxz;
        mb=i+(j-1)*nxz+(nz-1)*nx;
        mfp=mf+(nz-2)*nx;
        mbp=mb-(nz-2)*nx;
        ajx[mf-1]=ajx[mfp-1];
        ajx[mb-1]=ajx[mbp-1];
        ajy[mf-1]=ajy[mfp-1];
        ajy[mb-1]=ajy[mbp-1];
        ajz[mf-1]=ajz[mfp-1];
        ajz[mb-1]=ajz[mbp-1];
  }
}

	for(n=1;n<=nz;n++){
		for(l=1;l<miend;l++){
          i=l+(n-1)*nx;
          ajy[i-1]=0.0;
  }
      	for(l=meend+1;l<=nx;l++){
          i=l+(n-1)*nx;
          ajy[i-1]=0.0;
  }
  }

	for(i=1;i<=nxyz;i++)
        ajh[i-1]=ajx[i-1]*ex[i-1]+ajy[i-1]*ey[i-1]+ajz[i-1]*ez[i-1];
n=0;
	for(j=0;j<ny;j++){
		for(k=0;k<nz;k++){
			for(i=0;i<nx;i++){
			jx[i][j][k]=ajx[n];
			jy[i][j][k]=ajy[n];
			jz[i][j][k]=ajz[n];
			n++;
			}
		}
	}

	
		
}

void output(double xx[],double yy[],double zz[],
			double jx[nx][ny][nz],double jy[nx][ny][nz],double jz[nx][ny][nz])
{
	int i,j,k;
	FILE *fp,*gp,*hp;

  fp=fopen("jx.dat","w");
  gp=fopen("jy.dat","w");
  hp=fopen("jz.dat","w");
  
	j=0;
	for(i=0;i<nx;i++){
			for(k=0;k<nz;k++){
	fprintf(fp,"%lf %lf %lf\n",xx[i],zz[k],jx[i][j][k]);
	fprintf(gp,"%lf %lf %lf\n",xx[i],zz[k],jy[i][j][k]);
	fprintf(hp,"%lf %lf %lf\n",xx[i],zz[k],jz[i][j][k]);
			}
	fprintf(fp,"\n");
	fprintf(gp,"\n");
	fprintf(hp,"\n");
	}
	
	fclose(fp);
	fclose(gp);
	fclose(hp);

}
